#include "hmg.ch"
#include "hbextcdp.ch"

Function Main( cProcessIdExe1, cProcessFullNameExe1 )

Local nProcessID := GetCurrentProcessId()
Local cProcessName := GetProcessName( nProcessID )
Local cProcessFullName := GetProcessFullName( nProcessID )

DEFINE WINDOW Exe2 AT 0 , 400 WIDTH 350 HEIGHT 400 TITLE "EXE 2" MAIN;
	NOMINIMIZE; 
	NOMAXIMIZE; 
	NOSIZE 

	DEFINE RICHEDITBOX log_
   		ROW    10
   		COL    10
   		WIDTH  330
   		HEIGHT 300
   		VALUE ""
   		TOOLTIP ""
   		FONTSIZE 8
   		FONTBOLD .F.
   		FONTITALIC .F.
   		FONTUNDERLINE .F.
   		FONTSTRIKEOUT .F.
   		VISIBLE .T.
   		READONLY .T.
	END RICHEDITBOX

	@ 320,10 BUTTON BUTTON_1 CAPTION "Kill Exe1" ACTION KillExe1( cProcessIdExe1, cProcessFullNameExe1 )

   
	info_( "Exe2 path and name: " + ExeName() )
        info_( "Exe2 Process ID: " + hb_ValToStr( nProcessID ) )
        info_( "Exe2 Process Name: " + cProcessName )
	info_( "Exe2 Process Full Name: " + cProcessFullName )

	info_( "Exe1 Process ID to KILL: " + hb_ValToStr( cProcessIdExe1 ) )
        info_( "Exe1 Process Full Name to KILL: " + hb_ValToStr( cProcessFullNameExe1 ) )

	
END WINDOW
ACTIVATE WINDOW Exe2

QUIT 
Return Nil

****************************************************************************************
PROCEDURE info_( cMessage )

exe2.log_.CaretPos := LEN( exe2.log_.Value )
exe2.log_.AddText ( Exe2.log_.CaretPos ) := cMessage + CRLF

DO Events

RETURN Nil
**************************************************
PROCEDURE KillExe1( cProcessIDToKill, cProcessFullNameToKill )
Local aProcessesID := EnumProcessesID (), nID, i
Local lIsRunning := .F., nAttemp := 0

IF hb_isNil ( cProcessIDToKill ) .OR. hb_isNil ( cProcessFullNameToKill )
	info_ ( "The exe2.exe file was not executed from the exe1.exe file!" )
	RETURN
ENDIF

FOR i := 1 TO HMG_LEN ( aProcessesID )
	nID := aProcessesID [i]
	IF nID == Val ( cProcessIDToKill ) .AND. hmg_Upper( GetProcessFullName( nID ) ) == hmg_Upper ( cProcessFullNameToKill )
		lIsRunning := .T.	
	        info_ ( "Killing process ID " + cProcessIDToKill + " (" + GetProcessFullName( nID ) + ") ..." )
		TerminateProcess ( Val ( cProcessIDToKill ) )		
	ENDIF
NEXT i

IF !lIsRunning
	info_ ( "Process ID " + cProcessIDToKill + " (" + cProcessFullNameToKill + ") is not running!" )
	RETURN
ENDIF

DO WHILE nAttemp < 10
	nAttemp ++
	lIsRunning := .F.

	aProcessesID := EnumProcessesID ()

	FOR i := 1 TO HMG_LEN ( aProcessesID )
		nID := aProcessesID [i]
		IF nID == Val ( cProcessIDToKill ) .AND. hmg_Upper( GetProcessFullName( nID ) ) == hmg_Upper ( cProcessFullNameToKill )
			lIsRunning := .T.			
		ENDIF
	NEXT i

	IF !lIsRunning
		EXIT
	ENDIF 
ENDDO

IF lIsRunning
	info_ ( "Failed to terminate process ID " + cProcessIDToKill + " (" + cProcessFullNameToKill + ")" )
ELSE
	info_ ( "Successfully terminated process ID " + cProcessIDToKill + " (" + cProcessFullNameToKill + ")" )
ENDIF	

RETURN 
********************************