#include "hmg.ch"
#include "hbextcdp.ch"

Function Main()

Local nProcessID := GetCurrentProcessId()
Local cProcessName := GetProcessName( nProcessID )
Local cProcessFullName := GetProcessFullName( nProcessID )

DEFINE WINDOW Exe1 AT 0 , 0 WIDTH 350 HEIGHT 400 TITLE "EXE 1" MAIN;
	NOMINIMIZE; 
	NOMAXIMIZE; 
	NOSIZE 

	DEFINE RICHEDITBOX log_
   		ROW    10
   		COL    10
   		WIDTH  330
   		HEIGHT 300
   		VALUE ""
   		TOOLTIP ""
   		FONTSIZE 8
   		FONTBOLD .F.
   		FONTITALIC .F.
   		FONTUNDERLINE .F.
   		FONTSTRIKEOUT .F.
   		VISIBLE .T.
   		READONLY .T.
	END RICHEDITBOX

	@ 320,10 BUTTON BUTTON_1 CAPTION "Execute Exe2" ACTION RunExe2( nProcessID, cProcessFullName)

   
	info_( "Exe1 path and name: " + ExeName() )
        info_( "Exe1 Process ID: " + hb_ValToStr( nProcessID ) )
        info_( "Exe1 Process Name: " + cProcessName )
	info_( "Exe1 Process Full Name: " + cProcessFullName )

	
END WINDOW
ACTIVATE WINDOW Exe1

QUIT 
Return Nil

****************************************************************************************
PROCEDURE info_( cMessage )

exe1.log_.CaretPos := LEN( exe1.log_.Value )
exe1.log_.AddText ( Exe1.log_.CaretPos ) := cMessage + CRLF

DO Events

RETURN Nil
**************************************************
PROCEDURE RunExe2( nCurrentProcessID, cCurrentProcessFullName )
Local cExe2Name := HB_FNameDir( ExeName() ) + "exe2.exe"
Local aProcessesID := EnumProcessesID (), nID, i
Local cParam := AllTrim ( Str ( nCurrentProcessID ) ) + " " + cCurrentProcessFullName
Local lIsRunning := .F., nAttemp := 0

IF !File ( cExe2Name )
	info_ ( "The " + cExe2Name + " file doesn't exist!" )
	RETURN
ENDIF

FOR i := 1 TO HMG_LEN ( aProcessesID )
	nID := aProcessesID [i]
	IF hmg_Upper( GetProcessFullName( nID ) ) == hmg_Upper( cExe2Name )
		info_ ( "The " + cExe2Name + " file is already running!" )
		RETURN
	ENDIF
NEXT i

info_ ( "Running the " + cExe2Name + " file ...." )

EXECUTE FILE cExe2Name PARAMETERS cParam

DO WHILE .Not. lIsRunning .AND. nAttemp < 10 
	nAttemp ++
	aProcessesID := EnumProcessesID ()

	FOR i := 1 TO HMG_LEN ( aProcessesID )
		nID := aProcessesID [i]
		IF hmg_Upper( GetProcessFullName( nID ) ) == hmg_Upper( cExe2Name )
			lIsRunning := .T.
		ENDIF
	NEXT i
ENDDO

IF lIsRunning
	info_ ( "The " + cExe2Name + " file is running." )
ELSE
	info_ ( "The " + cExe2Name + " file isn't running!" )
ENDIF

RETURN 
********************************
